### IttfLoad process

An IttfLoad process is executed calling
	the static async method "load"
	of the module "wizzi-core/lib/ittf/ittf.js"

	The method "load" requires the parameters
		primaryIttfDocumentUri: String
		context: Object {
			modelContext: Object optional
			artifactGenerationContext: Object optional
			productionContext: Object optional
		}
		callback: Function

object ittf in wizzi.core/lib/ittf
	Manages the build-up of an IttfModel object
	from an IttfDocument source text.
	uses
		object modelProvider
		object loadContext
		object IttfModel
	method load
		param filepath
		param requestContext
			an object passed to the evaluator engine
		param callback

object (class) IttfModel in wizzi.core/lib/ittf/ittfModel.js
	Is created by object modelProvider for each source IttfDocument
	properties {
        uri: String // The location of the source IttfDocument.
        loadContext: Object, // The loadContext object
        lines: Array, // lexed source lines
        nodes: Array, // parsed source nodes
			node properties {
				name: String,
				value: String,
				tagSuffix: String, 
					'(' identifies a mixin call
				row: Number,
				col: Number,
				sourceKey: String,
				parent: Object,
				model: Object (cloned ittfModel)
			}
        sourceKey: String, // key to the source info of the IttfDocument
        modelKey: String // key to the cloned IttfModel
        
        ... these are set by the mixer, on the cloned object
        $mixerModelKey: String // the modelKey of the calling node
        $args: String // the value of the calling node
        $argArray: String // the $arg array of the calling node
        
        ... these are set by the parser on the original model, then cloned
        $params: // the node value of the $params node, if declared
    }

	methods
		load
			load an IttfDocument into an IttfModel using:
			lexer in wizzi.core/lib/ittf/lexer.js
			parser in wizzi.core/lib/ittf/parser.js
		clone
	comments
		An IttfModel is a parsed IttfDocument.
		The load method parses an IttfDocument content into a 'nodes' array.
		In the build-up of an Ittf model, the same Ittf document can be mixed 
		or included many times, so it is cloned when mixed or included.

object (class) loadContext in wizzi.core/lib/ittf/loadContext.js
	created by object modelProvider
	properties
		ittfSources = {
			ittfDocPath: String
			sourceKey: String
			content: String
				the raw content of the IttfDocument
			TODO isPrimary: Boolean
		}
		ittfDocumentDatas {
			ittfDocPath: String
			schema: String
			sourceKey: String
			modelKey: String
				The same IttfDocument can be mixed many times inside a Wizzi model.
				The ittfDocumentDatas collection stores a cloned instance of the loaded IttfModel,
				that is specific to a mixed document.
				Parameters passed to a document and variables declared in the document have
				document scope, so each cloned IttfModel has its local value context that will
				be associated to it (through the modelKey).
			ittfModel: Object (cloned ittfModel)
		}
	methods
		getSourceFilepath
			param sourceKey

object modelProvider in wizzi.core/lib/ittf/provider.js
	An instance of modelProvider is create for each IttfLoad execution
	Is created by object ittf
    properties : {
        schema: String,
        ittfSource: {
            path: uri,
            storeKind: String ['repo'|'filesystem'], 
            storeDB: String 
        },
        store: Object, // new ModelStore(ittfSource)
        loadContext: Object, // new LoadContext(),
        productionContext: Object, // context.productionContext
        _modelsCache: Array // of IttfModel
    }
	methods
		get
			param options
				properties
			param callback

object productionContext in wizzi.core/lib/production/context.js
	properties
	methods
		addIttfEvaluationScript
			called by wizzi.core/lib/ittf/evaluator.js
			writes a dump of the evaluation script
		addIttfDocument
			called by modelProvider

