// generator: /wizzi-labs/wizzi-lab-site/ittf/lib/artifacts/js/module/gen/main.js, utc time: Fri, 24 Feb 2017 19:35:25 GMT
'use strict';
var globalErrors = require('../../errors');

var md = module.exports = globalErrors;

function RepoIOError(message,uri,innerEx) {
    this.name = 'RepoIOError';
    this.message = message + '\nuri: ' + uri;
    this.stack = (new Error()).stack;
}

RepoIOError.prototype = Object.create(Error.prototype);
RepoIOError.prototype.constructor = RepoIOError;
md.RepoIOError = RepoIOError;

function IttfNotFoundError(resourceType,name,sourceUri) {
    this.name = 'IttfNotFoundError';
    this.message = resourceType + ': ' + name + ' not found, processing document ' + getSrcPathInfo(sourceUri);
    this.stack = (new Error()).stack;
}

IttfNotFoundError.prototype = Object.create(Error.prototype);
IttfNotFoundError.prototype.constructor = IttfNotFoundError;
md.IttfNotFoundError = IttfNotFoundError;

function getSrcPathInfo(srcPath) {
    if (typeof (srcPath) === 'string') {
        return srcPath;
    }
    if (srcPath && (typeof (srcPath) === 'object')) {
        var msg = getSrcPathInfoFromNode(srcPath);
        return msg ? msg : srcPath.toString();
    }
    return 'unavailable';
}

function getSrcPathInfoFromNode(node) {
    var msg = [];
    if (node) {
        if (node.WmtSourceLineInfo) {
            var info = node.WmtSourceLineInfo;
            msg.push((' at row: ' + info.row));
            msg.push((', col: ' + info.col));
            msg.push((', source: ' + info.source));
            msg.push((', in file: ' + 'TODO'));
        }
        else if (node.wzSourceLineInfo) {
            var info = node.wzSourceLineInfo;
            var filePath = 'TODO';
            if (node.wzSourceFilepath) {
                filePath = node.wzSourceFilepath(info.sourceKey);
            }
            msg.push((' at row: ' + info.row));
            msg.push((', col: ' + info.col));
            msg.push((', source: ' + info.sourceKey));
            msg.push((', in file: ' + filePath));
        }
    }
    return msg.length == 0 ? null : msg.join('');
}

