// generator: wizzi-lab-artifatcs/lib/js/module/gen/main.js, utc time: Thu, 16 Feb 2017 09:35:15 GMT
/**
    Configures and exposes services that the
     jsWizziRunner can access during the build-up
     and evaluation of IttfModel(s)
     see ../ittf/evaluator.js
     see ../ittf/esprima/jsWizziRunner.js
    
     Uses the service ../services/repository
*/
var wizzi;
var filefinder;
// RunnerServer class
RunnerServer = function(wizziObject, cwd) {
    // this is instantiated by wizzi
    // ensure the wizzi var is set when wizzi is initialized
    wizzi = wizziObject;
    filefinder = wizzi.services.filefinder;
    this.cwd = cwd;
    this.initReposiory();
    this.initApis();
}
RunnerServer.prototype.initReposiory = function() {
    var wizziSchema = require('wizzi-schema');
    var wizziFactory = require('wizzi-factory');
    this.repository = new wizzi.services.repository();
    this.registerPackage(wizziFactory);
    this.registerPackage(wizziSchema);
}
RunnerServer.prototype.initApis = function() {
    this.apis = {};
}
RunnerServer.prototype.registerPackage = function(package) {
    if (typeof package === 'string') {
        package = this.searchPackage(package);
    }
    else if (typeof package === 'function') {
        package = package();
    }
    if (typeof package === 'object') {
        console.log(wizzi.chalk.yellow('WIZZI RunnerServer. Registered WizziFactoryPackage: ' + package.name));
        this.repository.registerWizziFactoryPackage(package);
    }
    else {
        throw new TypeError('package must be of type object');
    }
}
RunnerServer.prototype.searchPackage = function(packageName) {
    var packagePath = filefinder.findNodePackage(packageName, this.cwd, true);
    return packagePath;
}
RunnerServer.prototype.loadWizziModel = function(wizzischema, ittfDocumentUri, context, callback) {
    this.repository.loadWizziModel(wizzischema, ittfDocumentUri, context, callback);
}
RunnerServer.prototype.transformModel = function(transformName, model, context, callback) {
    this.repository.transformModel(transformName, model, context, callback);
}
RunnerServer.prototype.loadWizziSchema = function(wfpackageuri, wizzischema, formatOptions, callback) {
    this.repository.loadWizziSchema(wfpackageuri, wizzischema, formatOptions, callback);
}
RunnerServer.prototype.registerApi = function(apiName, apiFunction) {
    this.apis[apiName] = apiFunction;
}
RunnerServer.prototype.callApi = function(apiName) {
    var api = this.apis[apiName];
    var args = Array.prototype.slice.call(arguments, 1);
    return api.apply(this, args);
}

module.exports = RunnerServer;
